Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 27232)
@@ -7726,4 +7620,22 @@
 		for(i=0;i<NUMVERTICES;i++) grdfieldout[i]=grdfield[i*nt+0];
 	}
+	//free resources
+	xDelete<IssmDouble>(grdfield);
+	xDelete<IssmDouble>(Centroid_loads);
+	for(l=0;l<SLGEOM_NUMLOADS;l++) xDelete<IssmDouble>(Subelement_loads[l]);
+	if (spatial_component!=0){
+		xDelete<IssmDouble>(horiz_projection);
+		xDelete<IssmDouble>(Centroid_loads_copy);
+		for(l=0;l<SLGEOM_NUMLOADS;l++) {
+			xDelete<IssmDouble>(Subelement_loads_copy[l]);
+			xDelete<IssmDouble>(horiz_projectionsub[l]);
+		}
+	}
+	if (computeviscous){
+		xDelete<IssmDouble>(viscoustimes);
+		if (computefuture){
+			xDelete<IssmDouble>(grdfieldinterp);
+		}
+	}
 
 } /*}}}*/
@@ -7731,4 +7643,5 @@
 void       Tria::SealevelchangeShift(GrdLoads* loads,  IssmDouble offset, SealevelGeometry* slgeom){ /*{{{*/
 
+	offset*=slgeom->LoadArea[SLGEOM_OCEAN][this->lid]; //kg.m^-2 to kg 
 	if(slgeom->isoceanin[this->lid]){
 		if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
Index: issm/trunk/src/c/classes/Elements/Tria.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.h	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Tria.h	(revision 27232)
@@ -171,5 +171,5 @@
 		#ifdef _HAVE_SEALEVELCHANGE_
 		void       GiaDeflection(Vector<IssmDouble>* wg,Vector<IssmDouble>* dwgdt,Matlitho* litho, IssmDouble* x,IssmDouble* y);
-		void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae);
+		void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae, int* lids);
 		void       SealevelchangeGeometrySubElementKernel(SealevelGeometry* slgeom);
 		void       SealevelchangeGeometrySubElementLoads(SealevelGeometry* slgeom, IssmDouble* areae);
@@ -244,5 +244,5 @@
 		void           UpdateConstraintsExtrudeFromBase(void);
 		void           UpdateConstraintsExtrudeFromTop(void);
-		void           SealevelchangeGxL(IssmDouble* sealevel, IssmDouble* G, IssmDouble** Gsub, IssmDouble* Grot, GrdLoads* loads, IssmDouble* polarmotionvector,SealevelGeometry* slgeom, int nel, bool percpu,int stackenum,bool computefuture);
+		void           SealevelchangeGxL(IssmDouble* grdfieldout, int spatial_component, int* AlphaIndex, int** AlphaIndexsub, int* AzimIndex, int**AzimIndexsub, IssmDouble* G, IssmDouble* Grot, GrdLoads* loads, IssmDouble* polarmotionvector, SealevelGeometry* slgeom, int nel, bool percpu, int viscousenum, bool computefuture);
 		/*}}}*/
 
Index: issm/trunk/src/c/classes/FemModel.cpp
===================================================================
--- issm/trunk/src/c/classes/FemModel.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/FemModel.cpp	(revision 27232)
@@ -283,5 +283,5 @@
 	pfclose(restartfid,restartfilename);
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<char>(femmodel_buffer);
 	xDelete<char>(restartfilename);
@@ -634,5 +634,5 @@
 	pfclose(restartfid,restartfilename);
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<char>(restartfilename);
 	xDelete<char>(femmodel_buffer);
@@ -1803,5 +1803,5 @@
 	mass_flux=all_mass_flux;
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	for(i=0;i<M;i++){
 		IssmDouble* matrix=array[i];
@@ -3165,5 +3165,5 @@
 	InputUpdateFromVectorx(this,vz,VzMeshEnum,VertexPIdEnum);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete vx;
 	delete vy;
@@ -4617,5 +4617,5 @@
 			}
 
-			/*Free ressources:*/
+			/*Free resources:*/
 			xDelete<double>(vertex_response);
 			xDelete<double>(qmu_response);
@@ -4668,5 +4668,5 @@
 	/*}}}*/
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	for(i=0;i<response_partitions_num;i++){
 		IssmDouble* matrix=response_partitions[i];
@@ -4712,5 +4712,5 @@
 	pY->Assemble();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(xx);
 	xDelete<IssmDouble>(yy);
@@ -4746,5 +4746,5 @@
 	pEast->Assemble();
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(latitude);
 	xDelete<IssmDouble>(longitude);
Index: issm/trunk/src/c/classes/GrdLoads.cpp
===================================================================
--- issm/trunk/src/c/classes/GrdLoads.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/GrdLoads.cpp	(revision 27232)
@@ -19,4 +19,5 @@
 GrdLoads::GrdLoads(int nel,SealevelGeometry* slgeom){ /*{{{*/
 
+	/*allocate:*/
 	vloads=new Vector<IssmDouble>(nel);
 	for (int i=0;i<SLGEOM_NUMLOADS;i++) vsubloads[i]=new Vector<IssmDouble>(slgeom->nbar[i]);
@@ -26,4 +27,11 @@
 
 	vsubsealevelloads=new Vector<IssmDouble>(slgeom->nbar[SLGEOM_OCEAN]);
+
+	/*make sure all pointers that are not allocated are NULL:*/
+	loads=NULL;
+	for (int i=0;i<SLGEOM_NUMLOADS;i++)subloads[i]=NULL;
+	sealevelloads=NULL;
+	subsealevelloads=NULL;
+
 
 }; /*}}}*/
@@ -50,4 +58,11 @@
 	}
 
+	/*Avoid leaks:*/
+	if(loads)xDelete<IssmDouble>(loads);
+	for (int i=0;i<SLGEOM_NUMLOADS;i++){
+		if(subloads[i])xDelete<IssmDouble>(subloads[i]);
+	}
+
+	/*Serialize:*/
 	loads=vloads->ToMPISerial();
 	for (int i=0;i<SLGEOM_NUMLOADS;i++){
@@ -64,13 +79,19 @@
 void GrdLoads::BroadcastSealevelLoads(void){ /*{{{*/
 
+	/*Avoid leakds:*/
+	if(sealevelloads)xDelete<IssmDouble>(sealevelloads);
+	if(subsealevelloads)xDelete<IssmDouble>(subsealevelloads);
+
+	/*Serialize:*/
 	sealevelloads=vsealevelloads->ToMPISerial();
 	subsealevelloads=vsubsealevelloads->ToMPISerial();
 
 } /*}}}*/
-void GrdLoads::SHDegree2Coefficients(IssmDouble* deg2coeff, FemModel* femmodel, SealevelGeometry* slgeom){
+void GrdLoads::SHDegree2Coefficients(IssmDouble* deg2coeff, FemModel* femmodel, SealevelGeometry* slgeom){ /*{{{*/
 
-	IssmDouble area,re, S;
+	IssmDouble re, S;
 	int ylmindex, intj;
 	IssmDouble deg2coeff_local[5];
+	//IssmDouble area;
 
 	femmodel->parameters->FindParam(&re,SolidearthPlanetRadiusEnum);
@@ -86,9 +107,8 @@
 		if(sealevelloads) S+=sealevelloads[element->Sid()];
 		if(S!=0){
-			element->Element::GetInputValue(&area,AreaEnum);
 
 			for (int c=0;c<5;c++){ //degree l=2 has 2*l+1=5 coefficients: 2,0; 2,1cos; 2,1sin; 2,2cos; 2,2sin
 				ylmindex=(4+c)*slgeom->localnel+element->lid; // starting at index=l^2
-				deg2coeff_local[c] += S*area/re/re*slgeom->Ylm[ylmindex];
+				deg2coeff_local[c] += S/re/re*slgeom->Ylm[ylmindex];
 			}
 		}
@@ -101,8 +121,8 @@
 				if(i==SLGEOM_OCEAN && sealevelloads) S+=subsealevelloads[intj];
 				if(S!=0){
-					area=slgeom->area_subel[i][intj];
+					//area=slgeom->area_subel[i][intj];
 					for (int c=0;c<5;c++){ //degree l=2 has 2*l+1=5 coefficients
 						ylmindex=(4+c)*slgeom->localnel+element->lid; // starting at index=l^2
-						deg2coeff_local[c] += S*area/re/re*slgeom->Ylm_subel[i][ylmindex];
+						deg2coeff_local[c] += S/re/re*slgeom->Ylm_subel[i][ylmindex];
 					}
 				}
@@ -119,3 +139,3 @@
 	ISSM_MPI_Bcast(&deg2coeff[2],1,ISSM_MPI_DOUBLE,0,IssmComm::GetComm());
 
-} 
+} /*}}}*/ 
Index: issm/trunk/src/c/classes/Inputs/ArrayInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/ArrayInput.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Inputs/ArrayInput.cpp	(revision 27232)
@@ -81,17 +81,38 @@
 	marshallhandle->call(object_enum);
 	marshallhandle->call(this->numberofelements_local);
+
+	/*Allocate memory if reading restart file*/
+	if(marshallhandle->OperationNumber() == MARSHALLING_LOAD){
+		_assert_(this->numberofelements_local>0);
+		_assert_(this->numberofelements_local<1e11);
+		if(this->numberofelements_local){
+			this->N                      = xNewZeroInit<int>(this->numberofelements_local);
+			this->values                 = xNewZeroInit<IssmDouble*>(this->numberofelements_local);
+		}
+		else{
+			this->N      = NULL;
+			this->values = NULL;
+		}
+	}
+
+	/*Marshall N*/
 	if(this->numberofelements_local){
 		marshallhandle->call(this->N,this->numberofelements_local);
+	}
+
+	/*Marshall individual arrays*/
+	if(this->numberofelements_local){
 		for(int i=0;i<this->numberofelements_local;i++){
-			if(this->values[i]){
+			if(this->N[i]){
+
+				/*Allocate if reading restart*/
+				if(marshallhandle->OperationNumber() == MARSHALLING_LOAD){
+					this->values[i] = xNew<IssmDouble>(this->N[i]);
+				}
+				_assert_(this->values[i]);
 				marshallhandle->call(this->values[i],this->N[i]);
 			}
 		}
 	}
-	else{
-		this->N      = NULL;
-		this->values = NULL;
-	}
-
 }
 /*}}}*/
Index: issm/trunk/src/c/classes/Inputs/Inputs.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/Inputs.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Inputs/Inputs.cpp	(revision 27232)
@@ -24,4 +24,5 @@
 #include "./DatasetInput.h"
 #include "./ArrayInput.h"
+#include "./IntArrayInput.h"
 using namespace std;
 /*}}}*/
@@ -167,4 +168,9 @@
 				this->inputs[index]=input;
 			}
+			else if(object_enum==ArrayInputEnum){
+				ArrayInput* input=new ArrayInput();
+				input->Marshall(marshallhandle);
+				this->inputs[index]=input;
+			}
 			else{
 				_error_("input "<<EnumToStringx(object_enum)<<" not supported");
@@ -566,4 +572,21 @@
 	input->GetArrayPtr(row,pvalues,pN);
 }/*}}}*/
+void Inputs::GetIntArrayPtr(int enum_in,int row,int** pvalues,int* pN){/*{{{*/
+
+	/*Get input id*/
+	int id = EnumToIndex(enum_in);
+
+	/*Create it if necessary*/
+	if(this->inputs[id]){
+		if(this->inputs[id]->ObjectEnum()!=IntArrayInputEnum) _error_(EnumToStringx(this->inputs[id]->ObjectEnum())<<" cannot return an int array");
+	}
+	else{
+		_error_("Input "<<EnumToStringx(enum_in)<<" not found");
+	}
+
+	/*Set input*/
+	IntArrayInput* input = xDynamicCast<IntArrayInput*>(this->inputs[id]);
+	input->GetArrayPtr(row,pvalues,pN);
+}/*}}}*/
 void Inputs::GetArray(int enum_in,int row,IssmDouble** pvalues,int* pN){/*{{{*/
 
@@ -581,4 +604,21 @@
 	/*Set input*/
 	ArrayInput* input = xDynamicCast<ArrayInput*>(this->inputs[id]);
+	input->GetArray(row,pvalues,pN);
+}/*}}}*/
+void Inputs::GetIntArray(int enum_in,int row,int** pvalues,int* pN){/*{{{*/
+
+	/*Get input id*/
+	int id = EnumToIndex(enum_in);
+
+	/*Create it if necessary*/
+	if(this->inputs[id]){
+		if(this->inputs[id]->ObjectEnum()!=IntArrayInputEnum) _error_(EnumToStringx(this->inputs[id]->ObjectEnum())<<" cannot return an int array");
+	}
+	else{
+		_error_("Input "<<EnumToStringx(enum_in)<<" not found");
+	}
+
+	/*Set input*/
+	IntArrayInput* input = xDynamicCast<IntArrayInput*>(this->inputs[id]);
 	input->GetArray(row,pvalues,pN);
 }/*}}}*/
@@ -730,4 +770,30 @@
 	input->SetInput(row,numlayers,values);
 }/*}}}*/
+void Inputs::SetIntArrayInput(int enum_in,int row,int* values,int numlayers){/*{{{*/
+
+	bool recreate = false;
+
+	/*Get input id*/
+	int id = EnumToIndex(enum_in);
+
+	/*Create it if necessary*/
+	if(this->inputs[id]){
+		if(this->inputs[id]->ObjectEnum()!=IntArrayInputEnum){
+			delete this->inputs[id];
+			recreate = true;
+		}
+	}
+	else{
+		recreate = true;
+	}
+
+	if(recreate){
+		this->inputs[id] = new IntArrayInput(this->numberofelements_local);
+	}
+
+	/*Set input*/
+	IntArrayInput* input = xDynamicCast<IntArrayInput*>(this->inputs[id]);
+	input->SetInput(row,numlayers,values);
+}/*}}}*/
 TransientInput* Inputs::SetDatasetTransientInput(int enum_in,int dataset_id,IssmDouble* times,int numtimes){/*{{{*/
 
Index: issm/trunk/src/c/classes/Inputs/Inputs.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/Inputs.h	(revision 27035)
+++ issm/trunk/src/c/classes/Inputs/Inputs.h	(revision 27232)
@@ -11,4 +11,5 @@
 class DatasetInput;
 class ArrayInput;
+class IntArrayInput;
 class ControlInput;
 class Parameters;
@@ -56,5 +57,7 @@
 		void     GetInputsInterpolations(int* pnuminputs,int** pinterpolations,int** penum);
 		void             GetArray(int enum_in,int row,IssmDouble** pvalues,int* pN);
+		void             GetIntArray(int enum_in,int row,int** pvalues,int* pN);
 		void             GetArrayPtr(int enum_in,int row,IssmDouble** pvalues,int* pN);
+		void             GetIntArrayPtr(int enum_in,int row,int** pvalues,int* pN);
 		SegInput*       GetSegInput(int enum_type);
 		TriaInput*      GetTriaInput(int enum_type);
@@ -82,4 +85,5 @@
 		TransientInput* SetDatasetTransientInput(int enum_in,int id,IssmDouble* times,int numtimes);
 		void  SetArrayInput(int enum_in,int row,IssmDouble* layers,int numlayers);
+		void  SetIntArrayInput(int enum_in,int row,int* layers,int numlayers);
 		void  SetTriaControlInputGradient(int enum_in,int interpolation,int numindices,int* indices,IssmDouble* values);
 		void  SetTriaControlInputGradient(int enum_in,int interpolation,int numindices,int* indices,IssmDouble* values,int n);
Index: issm/trunk/src/c/classes/Inputs/IntArrayInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/IntArrayInput.cpp	(revision 27232)
+++ issm/trunk/src/c/classes/Inputs/IntArrayInput.cpp	(revision 27232)
@@ -0,0 +1,145 @@
+/*!\file IntArrayInput.c
+ * \brief: implementation of the IntArrayInput object
+ */
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "../classes.h"
+#include "../../shared/shared.h"
+#include "./IntArrayInput.h"
+
+/*IntArrayInput constructors and destructor*/
+IntArrayInput::IntArrayInput(void){/*{{{*/
+
+	this->numberofelements_local = -1;
+	this->N                      = NULL;
+	this->values                 = NULL;
+
+}/*}}}*/
+IntArrayInput::IntArrayInput(int nbe_in){/*{{{*/
+
+	_assert_(nbe_in>0);
+	_assert_(nbe_in<1e11);
+	this->numberofelements_local = nbe_in;
+	this->N                      = xNewZeroInit<int>(this->numberofelements_local);
+	this->values                 = xNewZeroInit<int*>(this->numberofelements_local);
+
+}/*}}}*/
+IntArrayInput::~IntArrayInput(){/*{{{*/
+	if(this->values){
+		for(int i=0;i<this->numberofelements_local;i++) if(this->values[i]) xDelete<int>(this->values[i]);
+		xDelete<int>(this->values);
+	}
+	if(this->N) xDelete<int>(this->N);
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+Input* IntArrayInput::copy() {/*{{{*/
+
+	IntArrayInput* output = new IntArrayInput(this->numberofelements_local);
+
+	output->N = xNew<int>(this->numberofelements_local);
+	xMemCpy<int>(output->N,this->N,this->numberofelements_local);
+
+	output->values = xNew<int*>(this->numberofelements_local);
+	for(int i=0;i<this->numberofelements_local;i++){
+		if(this->values[i]){
+			_assert_(this->N[i]>0);
+			output->values[i] = xNew<int>(this->N[i]);
+			xMemCpy<int>(output->values[i],this->values[i],this->N[i]);
+		}
+		else{
+			output->values[i] = NULL;
+		}
+	}
+
+	return output;
+}
+/*}}}*/
+void IntArrayInput::DeepEcho(void){/*{{{*/
+	_printf_("IntArrayInput Echo:\n");
+	///_printf_("   Size:          "<<N<<"\n");
+	//printarray(this->values,this->M,this->N);
+	//_printf_(setw(15)<<"   IntArrayInput "<<setw(25)<<left<<EnumToStringx(this->enum_type)<<" "<<(value?"true":"false") << "\n");
+}
+/*}}}*/
+void IntArrayInput::Echo(void){/*{{{*/
+	this->DeepEcho();
+}
+/*}}}*/
+int  IntArrayInput::Id(void){/*{{{*/
+	return -1;
+}/*}}}*/
+void IntArrayInput::Marshall(MarshallHandle* marshallhandle){ /*{{{*/
+
+	int object_enum = IntArrayInputEnum;
+	marshallhandle->call(object_enum);
+	marshallhandle->call(this->numberofelements_local);
+	if(this->numberofelements_local){
+		marshallhandle->call(this->N,this->numberofelements_local);
+		for(int i=0;i<this->numberofelements_local;i++){
+			if(this->values[i]){
+				marshallhandle->call(this->values[i],this->N[i]);
+			}
+		}
+	}
+	else{
+		this->N      = NULL;
+		this->values = NULL;
+	}
+
+}
+/*}}}*/
+int  IntArrayInput::ObjectEnum(void){/*{{{*/
+	return IntArrayInputEnum;
+}
+/*}}}*/
+
+/*IntArrayInput management*/
+void IntArrayInput::SetInput(int row,int numindices,int* values_in){/*{{{*/
+
+	_assert_(this);
+	_assert_(row>=0 && row<this->numberofelements_local);
+
+	if(this->N[row] != numindices){
+		if(this->values[row]) xDelete<int>(this->values[row]);
+		this->values[row] = xNew<int>(numindices);
+	}
+
+	int *el_values = this->values[row];
+	for(int i=0;i<numindices;i++) el_values[i] = values_in[i];
+
+	this->N[row] = numindices;
+}
+/*}}}*/
+void IntArrayInput::GetArray(int row,int** pvalues,int* pN){/*{{{*/
+
+	_assert_(this);
+	_assert_(row>=0 && row<this->numberofelements_local);
+	if(pvalues){
+		int* outvalues = xNew<int>(this->N[row]);
+		xMemCpy<int>(outvalues,this->values[row],this->N[row]);
+		*pvalues = outvalues;
+	}
+	if(pN){
+		*pN = this->N[row];
+	}
+}
+/*}}}*/
+void IntArrayInput::GetArrayPtr(int row,int** pvalues,int* pN){/*{{{*/
+
+	_assert_(this);
+	_assert_(row>=0 && row<this->numberofelements_local);
+	if(pvalues){
+		*pvalues = this->values[row];
+	}
+	if(pN){
+		*pN = this->N[row];
+	}
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/Inputs/IntArrayInput.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/IntArrayInput.h	(revision 27232)
+++ issm/trunk/src/c/classes/Inputs/IntArrayInput.h	(revision 27232)
@@ -0,0 +1,34 @@
+#ifndef _INTARRAYINPUT_H_
+#define _INTARRAYINPUT_H_
+
+/*Headers:*/
+#include "./Input.h"
+
+class IntArrayInput: public Input{
+
+	private:
+		int         numberofelements_local;
+		int*        N;
+		int** values;
+
+	public:
+		/*IntArrayInput constructors, destructors: {{{*/
+		IntArrayInput();
+		IntArrayInput(int nbe_in);
+		~IntArrayInput();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		Input *copy();
+		void    DeepEcho();
+		void    Echo();
+		int     Id();
+		void    Marshall(MarshallHandle* marshallhandle);
+		int     ObjectEnum();
+		/*}}}*/
+		/*IntArrayInput management:*/
+		void SetInput(int row,int numinds,int* values_in);
+		void GetArray(int row,int** pvalues,int* pN);
+		void GetArrayPtr(int row,int** pvalues,int* pN);
+
+};
+#endif  /* _INTARRAYINPUT_H */
Index: issm/trunk/src/c/classes/Inputs/TransientInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/TransientInput.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Inputs/TransientInput.cpp	(revision 27232)
@@ -9,4 +9,5 @@
 #endif
 
+#include <numeric>
 #include "./TransientInput.h"
 #include "./TriaInput.h"
@@ -208,5 +209,5 @@
 
 	/*This is a new time step! we need to add it to the list*/
-	if(this->numtimesteps>0 && time<this->timesteps[this->numtimesteps-1]) _error_("timestep values must increase sequentially");
+	if(this->numtimesteps>0 && time<this->timesteps[this->numtimesteps-1]) _error_("timestep values must increase sequentially, here " << this->timesteps[this->numtimesteps-1] <<" is the last step but smaller than the preceding "<< time<<"\n");
 
 	IssmDouble *old_timesteps = NULL;
@@ -433,7 +434,8 @@
 
 	/*First, recover current time from parameters: */
-	bool linear_interp,cycle;
+	bool linear_interp,average,cycle;
 	IssmDouble dt;
 	this->parameters->FindParam(&linear_interp,TimesteppingInterpForcingEnum);
+	this->parameters->FindParam(&average,TimesteppingAverageForcingEnum);
 	this->parameters->FindParam(&cycle,TimesteppingCycleForcingEnum);
 	this->parameters->FindParam(&dt,TimesteppingTimeStepEnum);          /*transient core time step*/
@@ -471,6 +473,9 @@
 
 	/*Figure step out*/
-	int offset;
+	int offset, prevoffset;
 	if(!binary_search(&offset,time,this->timesteps,this->numtimesteps)){
+		_error_("Input not found (is TransientInput sorted ?)");
+	}
+	if(!binary_search(&prevoffset,reCast<IssmDouble>(time-dt),this->timesteps,this->numtimesteps)){
 		_error_("Input not found (is TransientInput sorted ?)");
 	}
@@ -488,4 +493,22 @@
 		this->current_step = 0.;
 		this->current_input = this->inputs[0]->copy();
+
+	}
+	else if(offset-prevoffset>1 && prevoffset >=0 && average){
+		/*get values for the last time: */
+		_assert_(time>=this->timesteps[offset]);
+
+		/*If already processed return*/
+		if(this->current_step==reCast<IssmDouble>(offset)) return;
+
+		/*Prepare input*/
+		if(this->current_input) delete this->current_input;
+		this->current_step  = reCast<IssmDouble>(offset);
+
+		this->current_input = this->inputs[prevoffset]->copy();
+		for(int i=prevoffset+1;i<offset;i++) {
+			this->current_input->AXPY(this->inputs[i],+1.0);
+		}
+		this->current_input->Scale(1./(offset-prevoffset));
 
 	}
@@ -535,4 +558,5 @@
 	IssmDouble  timespan,mid_step;
 	int         found,start_offset,end_offset,input_offset;
+
 
 	/*go through the timesteps, and grab offset for start and end*/
@@ -573,6 +597,5 @@
 			_assert_(dt>0.);
 		}
-		Input* stepinput=this->inputs[offset+1];
-
+		Input* stepinput=this->inputs[offset+1]->copy();
 		switch(averaging_method){
 			case 0: /*Arithmetic mean*/
@@ -608,4 +631,5 @@
 				_error_("averaging method is not recognised");
 		}
+		delete stepinput;
 		dtsum+=dt;
 		offset+=1;
Index: issm/trunk/src/c/classes/IoModel.cpp
===================================================================
--- issm/trunk/src/c/classes/IoModel.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/IoModel.cpp	(revision 27232)
@@ -1180,5 +1180,5 @@
 		integer_matrix=NULL;
 	}
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmPDouble>(matrix);
 
@@ -1747,5 +1747,5 @@
 	}
 
-	/*Free ressources*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(doublearray);
 }
@@ -1947,5 +1947,5 @@
 			break;
 	}
-	/*Free ressources*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(doublearray);
 }
@@ -2026,5 +2026,5 @@
 			break;
 	}
-	/*Free ressources*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(doublearray);
 }
@@ -2260,5 +2260,5 @@
 		}
 	}
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(codes);
 	xDelete<fpos_t>(file_positions);
@@ -2313,5 +2313,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<fpos_t>(file_positions);
 	xDelete<int>(codes);
@@ -2366,5 +2366,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<fpos_t>(file_positions);
 	xDelete<int>(codes);
@@ -2455,5 +2455,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<fpos_t>(file_positions);
 	xDelete<int>(codes);
@@ -2558,5 +2558,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<fpos_t>(file_positions);
 	xDelete<int>(codes);
Index: issm/trunk/src/c/classes/Loads/Friction.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Friction.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Loads/Friction.cpp	(revision 27232)
@@ -321,10 +321,10 @@
 
 	/*This routine calculates the basal friction coefficient
-	  alpha2= drag^2 * Neff ^r * | vel | ^(s-1), with Neff=rho_ice*g*thickness+rho_ice*g*base, r=q/p and s=1/p**/
+	  alpha2= drag^2 * Neff ^r * | vel | ^(s-1), with Neff=rho_ice*g*thickness+rho_ice*g*base, r=q/p and s=1/p
+	  alpha2= min(drag^2 * Neff ^r * | vel | ^(s-1), drag_coulomb^2 * Neff*/
 
 	/*diverse: */
 	IssmDouble  r,s;
 	IssmDouble  drag_p, drag_q;
-	IssmDouble  thickness,base,floatation_thickness,sealevel;
 	IssmDouble  drag_coefficient,drag_coefficient_coulomb;
 	IssmDouble  alpha2,alpha2_coulomb;
@@ -333,7 +333,4 @@
 	element->GetInputValue(&drag_p,gauss,FrictionPEnum);
 	element->GetInputValue(&drag_q,gauss,FrictionQEnum);
-	element->GetInputValue(&thickness, gauss,ThicknessEnum);
-	element->GetInputValue(&base, gauss,BaseEnum);
-	element->GetInputValue(&sealevel, gauss,SealevelEnum);
 	element->GetInputValue(&drag_coefficient, gauss,FrictionCoefficientEnum);
 	element->GetInputValue(&drag_coefficient_coulomb, gauss,FrictionCoefficientcoulombEnum);
@@ -347,5 +344,21 @@
 
 	/*Get effective pressure*/
-	IssmDouble Neff = EffectivePressure(gauss);
+	bool ispwStochastic;
+	IssmDouble Neff;
+	element->parameters->FindParam(&ispwStochastic,StochasticForcingIsWaterPressureEnum);
+	if(ispwStochastic){
+		/*Retrieve stochastic water pressure and compute ice pressure*/
+		IssmDouble p_ice,p_water,Neff_limit;
+		element->GetInputValue(&p_water,gauss,FrictionCoulombWaterPressureEnum);
+		element->parameters->FindParam(&Neff_limit,FrictionEffectivePressureLimitEnum);
+		p_ice = IcePressure(gauss);
+		Neff  = max(Neff_limit*p_ice, p_ice - p_water);
+	}	
+	else{
+		/*Compute effective pressure directly*/
+		Neff = EffectivePressure(gauss);
+	}
+	
+	/*Get velocity magnitude*/
 	IssmDouble vmag = VelMag(gauss);
 
@@ -360,11 +373,10 @@
 	}
 
-	floatation_thickness=0;
-	if(base<0) floatation_thickness=-(rho_water/rho_ice)*base;
 	if(vmag==0.){
 		alpha2_coulomb=0.;
 	}
 	else{
-		alpha2_coulomb=drag_coefficient_coulomb*drag_coefficient_coulomb*rho_ice*gravity*max(0.,thickness-floatation_thickness)/vmag;
+		//alpha2_coulomb=drag_coefficient_coulomb*drag_coefficient_coulomb*rho_ice*gravity*max(0.,thickness-floatation_thickness)/vmag;
+		alpha2_coulomb=drag_coefficient_coulomb*drag_coefficient_coulomb*Neff/vmag;
 	}
 
@@ -749,5 +761,5 @@
 	 *               C |u_b|^(m-1)
 	 * alpha2= __________________________
-	 *          (1+(C/(Cmax N))^1/m |u_b| )^m
+	 *          (1+(C/(Cmax Neff))^1/m |u_b| )^m
 	 *
 	 * */
@@ -764,14 +776,30 @@
 	C = coeff*coeff;
 
-	/*Get effective pressure and velocity magnitude*/
-	IssmDouble N  = EffectivePressure(gauss);
+	/*Get effective pressure*/
+	bool ispwStochastic;
+	IssmDouble Neff;
+	element->parameters->FindParam(&ispwStochastic,StochasticForcingIsWaterPressureEnum);
+	if(ispwStochastic){
+		/*Retrieve stochastic water pressure and compute ice pressure*/
+		IssmDouble p_ice,p_water,Neff_limit;
+		element->GetInputValue(&p_water,gauss,FrictionSchoofWaterPressureEnum);
+		element->parameters->FindParam(&Neff_limit,FrictionEffectivePressureLimitEnum);
+		p_ice = IcePressure(gauss);
+		Neff  = max(Neff_limit*p_ice, p_ice - p_water);
+	}	
+	else{
+		/*Compute effective pressure directly*/
+		Neff = EffectivePressure(gauss);
+	}
+
+	/*Get velocity magnitude*/
 	IssmDouble ub = VelMag(gauss);
 
 	/*Compute alpha^2*/
-	if((ub<1e-10) ||(N==0.0)){
+	if((ub<1e-10) ||(Neff==0.0)){
 		alpha2 = 0.;
 	}
 	else{
-		alpha2= (C*pow(ub,m-1.)) / pow(1.+  pow(C/(Cmax*N),1./m)*ub,m);
+		alpha2= (C*pow(ub,m-1.)) / pow(1.+  pow(C/(Cmax*Neff),1./m)*ub,m);
 	}
 
Index: issm/trunk/src/c/classes/Materials/Matlitho.cpp
===================================================================
--- issm/trunk/src/c/classes/Materials/Matlitho.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Materials/Matlitho.cpp	(revision 27232)
@@ -88,5 +88,5 @@
 	for (int i=0;i<this->numlayers;i++)this->issolid[i]=reCast<bool,IssmDouble>(issolidd[i]);*/
 
-	/*free ressources: */
+	/*Free resources: */
 	xDelete<IssmDouble>(rheologymodeld);
 	xDelete<IssmDouble>(issolidd);
Index: issm/trunk/src/c/classes/Misfit.cpp
===================================================================
--- issm/trunk/src/c/classes/Misfit.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Misfit.cpp	(revision 27232)
@@ -178,5 +178,5 @@
 			 misfit=sqrt(misfit_t/count);
 
-			 /*Free ressources:*/
+			 /*Free resources:*/
 			 xDelete<IssmDouble>(model);
 			 xDelete<IssmDouble>(observation);
@@ -213,5 +213,5 @@
 			 if(time==finaltime)this->lock=1;
 
-			 /*Free ressources:*/
+			 /*Free resources:*/
 			 xDelete<IssmDouble>(model);
 			 xDelete<IssmDouble>(observation);
Index: issm/trunk/src/c/classes/Node.cpp
===================================================================
--- issm/trunk/src/c/classes/Node.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Node.cpp	(revision 27232)
@@ -838,5 +838,5 @@
 		else doflist=NULL;
 
-		/*Free ressources:*/
+		/*Free resources:*/
 		xDelete<int>(ndof_list);
 	}
Index: issm/trunk/src/c/classes/Params/Parameters.cpp
===================================================================
--- issm/trunk/src/c/classes/Params/Parameters.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Params/Parameters.cpp	(revision 27232)
@@ -656,5 +656,5 @@
 	strcpy(outstring,strings[found]);
 
-	/*Free ressources*/
+	/*Free resources:*/
 	for(i=0;i<numanalyses;i++){
 		xDelete<char>(toolkits[i]);
Index: issm/trunk/src/c/classes/SealevelGeometry.cpp
===================================================================
--- issm/trunk/src/c/classes/SealevelGeometry.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/SealevelGeometry.cpp	(revision 27232)
@@ -115,11 +115,11 @@
 
 } /*}}}*/
-int SealevelGeometry::GEnum(int l){ /*{{{*/
+int SealevelGeometry::AlphaIndexEnum(int l){ /*{{{*/
 
 	int output = -1;
 	switch(l){
-		case SLGEOM_OCEAN: output=SealevelchangeGsubelOceanEnum; break;
-		case SLGEOM_ICE:   output=SealevelchangeGsubelIceEnum;   break;
-		case SLGEOM_WATER: output=SealevelchangeGsubelHydroEnum; break;
+		case SLGEOM_OCEAN: output=SealevelchangeAlphaIndexOceanEnum; break;
+		case SLGEOM_ICE:   output=SealevelchangeAlphaIndexIceEnum;   break;
+		case SLGEOM_WATER: output=SealevelchangeAlphaIndexHydroEnum; break;
 		default: _error_("not supported");
 	}
@@ -127,35 +127,11 @@
 
 } /*}}}*/
-int SealevelGeometry::GUEnum(int l){ /*{{{*/
+int SealevelGeometry::AzimuthIndexEnum(int l){ /*{{{*/
 
 	int output = -1;
 	switch(l){
-		case SLGEOM_OCEAN: output=SealevelchangeGUsubelOceanEnum; break;
-		case SLGEOM_ICE:   output=SealevelchangeGUsubelIceEnum;   break;
-		case SLGEOM_WATER: output=SealevelchangeGUsubelHydroEnum; break;
-		default: _error_("not supported");
-	}
-	return output;
-
-} /*}}}*/
-int SealevelGeometry::GNEnum(int l){ /*{{{*/
-
-	int output = -1;
-	switch(l){
-		case SLGEOM_OCEAN: output=SealevelchangeGNsubelOceanEnum; break;
-		case SLGEOM_ICE:   output=SealevelchangeGNsubelIceEnum;   break;
-		case SLGEOM_WATER: output=SealevelchangeGNsubelHydroEnum; break;
-		default: _error_("not supported");
-	}
-
-	return output;
-} /*}}}*/
-int SealevelGeometry::GEEnum(int l){ /*{{{*/
-
-	int output = -1;
-	switch(l){
-		case SLGEOM_OCEAN: output=SealevelchangeGEsubelOceanEnum; break;
-		case SLGEOM_ICE:   output=SealevelchangeGEsubelIceEnum;   break;
-		case SLGEOM_WATER: output=SealevelchangeGEsubelHydroEnum; break;
+		case SLGEOM_OCEAN: output=SealevelchangeAzimuthIndexOceanEnum; break;
+		case SLGEOM_ICE:   output=SealevelchangeAzimuthIndexIceEnum;   break;
+		case SLGEOM_WATER: output=SealevelchangeAzimuthIndexHydroEnum; break;
 		default: _error_("not supported");
 	}
Index: issm/trunk/src/c/classes/SealevelGeometry.h
===================================================================
--- issm/trunk/src/c/classes/SealevelGeometry.h	(revision 27035)
+++ issm/trunk/src/c/classes/SealevelGeometry.h	(revision 27232)
@@ -45,8 +45,6 @@
 		void InitializeMappingsAndBarycentres(void);
 		void Assemble(void);
-		int GEnum(int l);
-		int GUEnum(int l);
-		int GNEnum(int l);
-		int GEEnum(int l);
+		int AlphaIndexEnum(int l);
+		int AzimuthIndexEnum(int l);
 		void BuildSphericalHarmonics(void);
 };
Index: issm/trunk/src/c/classes/Vertices.cpp
===================================================================
--- issm/trunk/src/c/classes/Vertices.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Vertices.cpp	(revision 27232)
@@ -168,5 +168,5 @@
 	IssmDouble* lon_serial=lon->ToMPISerial();
 
-	/*free ressources: */
+	/*Free resources: */
 	*plat = lat_serial;
 	*plon = lon_serial;
Index: issm/trunk/src/c/classes/gauss/GaussSeg.cpp
===================================================================
--- issm/trunk/src/c/classes/gauss/GaussSeg.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/gauss/GaussSeg.cpp	(revision 27232)
@@ -43,5 +43,5 @@
 	}
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<IssmPDouble>(pcoords1);
 	xDelete<IssmPDouble>(pweights);
